//
//  PushMessage.h
//  DemoAlivcLive
//
//  Created by shiping.csp on 2017/1/11.
//  Copyright © 2017年 Alivc. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "LiveInviteInfo.h"
#import <AlivcLiveChatRoom/AlivcLiveChatRoom.h>

@protocol RecieveMessageDelegate <NSObject>

//邀请连麦
@optional
- (void)onGetInviteMessage:(NSString *)inviterUid inviterName:(NSString*)inviterName inviterType:(int)inviterType;

//同意连麦
@optional
- (void)onGetInviteAgreeMessage:(NSString*)inviteeUid inviteeName:(NSString*)inviteeName inviteeRoomId:(NSString*)inviteeRoomId inviterRoomId:(NSString*)inviterRoomId mainPlayUrl:(NSURL*)mainPlayUrl rtmpUrl:(NSString*)rtmpUrl otherPlayUrls:(NSArray*)otherPlayUrls otherPlayUids:(NSArray*)otherPlayUids;

//不同意连麦
@optional
- (void)onGetInviteDisAgreeMessage:(NSString*)inviteeUid inviteeName:(NSString*)inviteeName;

//主播结束连麦
@optional
- (void)onGetHostCloseVideoCallMessage:(NSString*)roomId uid:(NSString*)uid name:(NSString*)name;

//连麦混流成功
@optional
- (void)onGetMixSucMessage:(NSString*)mainRoomId;

//评论
@optional
- (void)onGetCommentMessage:(NSString*)uid name:(NSString*)name comment:(NSString*)comment;

//加入直播间
@optional
- (void)onGetInRoomMessage:(NSString*)name;

//离开直播间
@optional
- (void)onGetOutRoomMessage:(NSString*)name;

//点赞
@optional
- (void)onGetLikeMessage:(NSString*)uid name:(NSString*)name;

//直播结束
@optional
- (void)onGetCloseLiveMessage:(NSString*)roomId;

//开始推流
@optional
- (void)onGetStartLiveMessage:(NSString*)roomId uid:(NSString*)uid name:(NSString*)name playUrl:(NSString*)playUrl;

//中断推流
@optional
- (void)onGetInterruptLiveMessage:(NSString*)roomId uid:(NSString*)uid name:(NSString*)name;

//混流失败
@optional
- (void)onGetMixFailureMessage:(NSString*)mainRoomId message:(NSString*)message;

//连麦混流结束
@optional
- (void)onGetMixEndMessage:(NSString*)roomId uid:(NSString*)uid name:(NSString*)name;

//连麦混流状态
@optional
- (void)onGetMixStatusMessage:(NSString*)mainMixRoomId mixRoomId:(NSString*)mixRoomId message:(NSString*)message code:(NSString*)code;

//加入连麦
@optional
- (void)onGetJoinVideoChatMessage:(LiveInviteInfo*)inviteInfo;

//离开连麦
@optional
- (void)onGetLeaveVideoChatMessage:(LiveInviteInfo*)inviteInfo;

//掉线情况
//0: 用户掉线
//1: server端掉线
@optional
- (void)onGetNetworkStatusMessage:(int)offlineType;

@end

@interface RecieveMessageManager : NSObject<AlivcLiveClientReceiveMessageDelegate,AlivcLiveConnectionStatusChangeDelegate>

@property (nonatomic, assign) id<RecieveMessageDelegate> delegate;

@end
