//
//  PushMessage.m
//  DemoAlivcLive
//
//  Created by shiping.csp on 2017/1/11.
//  Copyright © 2017年 Alivc. All rights reserved.
//

#import "RecieveMessageManager.h"

@implementation RecieveMessageManager

- (instancetype)init
{
    self = [super init];
    if (self) {
        self.delegate = nil;
        [[AlivcLiveClient shareClient] setAlivcLiveClientReceiveMessageDelegate:self];
        [[AlivcLiveClient shareClient] setAlivcLiveConnectionStatusChangeDelegate:self];
    }
    return self;
}

- (void)onReceivedChatMessage:(NSString *)message {
    
    NSLog(@"收到消息 txt -- %@",message);
    NSData *jsonData = [message dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData options:NSJSONReadingMutableContainers error:&err];
    if (err) {
        NSLog(@"主播端推送信息JSON解析失败");
        return;
    }
    
    NSInteger type = [[dic objectForKey:@"type"] integerValue];
    switch (type) {
        case 1:
        {
            int nInviterType = 1;
            NSString *inviterUid = [dic[@"data"] objectForKey:@"inviterUid"];
            NSString* strInviterUid = [NSString stringWithFormat:@"%d",[inviterUid intValue]];
            NSString *inviterName = [dic[@"data"] objectForKey:@"inviterName"];
            NSString *inviterType = [dic[@"data"] objectForKey:@"inviterType"];
            
            if (inviterType) {
                nInviterType = [inviterType intValue];
            }
            
            if (self.delegate&& [self.delegate respondsToSelector:@selector(onGetInviteMessage:inviterName:inviterType:)]) {
                [self.delegate onGetInviteMessage:strInviterUid inviterName:inviterName inviterType:nInviterType];
            }
        }
        break;
            
        case 2:
        {
            NSString *inviterUid = [dic[@"data"] objectForKey:@"inviteeUid"];
            NSString* strInviterUid = [NSString stringWithFormat:@"%d",[inviterUid intValue]];
            NSString *inviteeName = [dic[@"data"] objectForKey:@"inviteeName"];
            NSString *inviteeRoomId = [dic[@"data"] objectForKey:@"inviteeRoomId"];
            NSString *inviterRoomId = [dic[@"data"] objectForKey:@"inviterRoomId"];
            NSString *mainPlayUrl = [dic[@"data"] objectForKey:@"mainPlayUrl"];
            NSString *rtmpUrl = [dic[@"data"] objectForKey:@"rtmpUrl"];
            NSURL* playUrl = [NSURL URLWithString:mainPlayUrl];
            NSArray* playUrls = [dic[@"data"] objectForKey:@"playUrls"];
            
            NSMutableArray<NSURL*>* playArrays = [[NSMutableArray alloc] init];
            NSMutableArray<NSString*>* playUidArrays = [[NSMutableArray alloc] init];
            
            for (NSDictionary* playDic in playUrls) {
                [playArrays addObject:[NSURL URLWithString:[playDic objectForKey:@"url"]]];
                
                NSString *strUid = [NSString stringWithFormat:@"%d",[[playDic objectForKey:@"uid"] intValue]];
                [playUidArrays addObject:strUid];
            }
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetInviteAgreeMessage:inviteeName:inviteeRoomId:inviterRoomId:mainPlayUrl:rtmpUrl:otherPlayUrls:otherPlayUids:)]) {
                [self.delegate onGetInviteAgreeMessage:strInviterUid inviteeName:inviteeName inviteeRoomId:inviteeRoomId inviterRoomId:inviterRoomId mainPlayUrl:playUrl rtmpUrl:rtmpUrl otherPlayUrls:playArrays otherPlayUids:playUidArrays];
            }
        }
        break;
            
        case 3:
        {
            NSString *inviterUid = [dic[@"data"] objectForKey:@"inviteeUid"];
            NSString* strInviterUid = [NSString stringWithFormat:@"%d",[inviterUid intValue]];
            NSString *inviteeName = [dic[@"data"] objectForKey:@"inviteeName"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetInviteDisAgreeMessage:inviteeName:)]) {
                [self.delegate onGetInviteDisAgreeMessage:strInviterUid inviteeName:inviteeName];
            }
        }
        break;
            
        case 4:
        {
            NSString *roomId = [dic[@"data"] objectForKey:@"roomId"];
            NSNumber *uid = [dic[@"data"] objectForKey:@"uid"];
            NSString *strUid = [NSString stringWithFormat:@"%d",[uid intValue]];
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetHostCloseVideoCallMessage:uid:name:)]) {
                [self.delegate onGetHostCloseVideoCallMessage:roomId uid:strUid name:name];
            }
        }
        break;
            
        case 5:
        {
            NSString *mainRoomId = [dic[@"data"] objectForKey:@"mainRoomId"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetMixSucMessage:)]) {
                [self.delegate onGetMixSucMessage:mainRoomId];
            }
        }
        break;

        case 6:
        {
            NSNumber *uid = [dic[@"data"] objectForKey:@"uid"];
            NSString *strUid = [NSString stringWithFormat:@"%d",[uid intValue]];
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            NSString *comment = [dic[@"data"] objectForKey:@"comment"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetCommentMessage:name:comment:)]) {
                [self.delegate onGetCommentMessage:strUid name:name comment:comment];
            }
        }
        break;
            
        case 7:
        {
            NSNumber *uid = [dic[@"data"] objectForKey:@"uid"];
            NSString *strUid = [NSString stringWithFormat:@"%d",[uid intValue]];
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetLikeMessage:name:)]) {
                [self.delegate onGetLikeMessage:strUid name:name];
            }
        }
        break;
            
        case 8:
        {
            NSString *roomId = [dic[@"data"] objectForKey:@"roomId"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetCloseLiveMessage:)]) {
                [self.delegate onGetCloseLiveMessage:roomId];
            }
        }
        break;
            
        case 9:
        {
            NSString *roomId = [dic[@"data"] objectForKey:@"roomId"];
            NSNumber *uid = [dic[@"data"] objectForKey:@"uid"];
            NSString *strUid = [NSString stringWithFormat:@"%d",[uid intValue]];
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            NSString *playUrl = [dic[@"data"] objectForKey:@"playUrl"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetStartLiveMessage:uid:name:playUrl:)]) {
                [self.delegate onGetStartLiveMessage:roomId uid:strUid name:name playUrl:playUrl];
            }
        }
        break;
            
        case 10:
        {
            NSString *roomId = [dic[@"data"] objectForKey:@"roomId"];
            NSNumber *uid = [dic[@"data"] objectForKey:@"uid"];
            NSString *strUid = [NSString stringWithFormat:@"%d",[uid intValue]];
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetInterruptLiveMessage:uid:name:)]) {
                [self.delegate onGetInterruptLiveMessage:roomId uid:strUid name:name];
            }
        }
        break;
            
        case 11:
        {
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetInRoomMessage:)]) {
                [self.delegate onGetInRoomMessage:name];
            }
        }
        break;
            
        case 12:
        {
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetOutRoomMessage:)]) {
                [self.delegate onGetOutRoomMessage:name];
            }
        }
        break;
            
        case 14:
        {
            NSString *mainRoomId = [dic[@"data"] objectForKey:@"mainRoomId"];
            NSString *message = [dic[@"data"] objectForKey:@"message"];

            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetMixFailureMessage:message:)]) {
                [self.delegate onGetMixFailureMessage:mainRoomId message:message];
            }
        }
        break;
            
        case 15:
        {
            NSString *roomId = [dic[@"data"] objectForKey:@"roomId"];
            NSNumber *uid = [dic[@"data"] objectForKey:@"uid"];
            NSString *strUid = [NSString stringWithFormat:@"%d",[uid intValue]];
            NSString *name = [dic[@"data"] objectForKey:@"name"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetMixEndMessage:uid:name:)]) {
                [self.delegate onGetMixEndMessage:roomId uid:strUid name:name];
            }
        }
        break;
            
        case 16:
        {
            NSString *mainMixRoomId = [dic[@"data"] objectForKey:@"mainMixRoomId"];
            NSString *mixRoomId = [dic[@"data"] objectForKey:@"mixRoomId"];
            NSString *message = [dic[@"data"] objectForKey:@"message"];
            NSString *code = [dic[@"data"] objectForKey:@"code"];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetMixStatusMessage:mixRoomId:message:code:)]) {
                [self.delegate onGetMixStatusMessage:mainMixRoomId mixRoomId:mixRoomId message:message code:code];
            }
        }
        break;
            
        case 18:
        {
            LiveInviteInfo *info = [[LiveInviteInfo alloc] init];
            [info setValuesForKeysWithDictionary:dic[@"data"]];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetJoinVideoChatMessage:)]) {
                [self.delegate onGetJoinVideoChatMessage:info];
            }
        }
        break;
            
        case 19:
        {
            LiveInviteInfo *info = [[LiveInviteInfo alloc] init];
            [info setValuesForKeysWithDictionary:dic[@"data"]];
            
            if (self.delegate && [self.delegate respondsToSelector:@selector(onGetLeaveVideoChatMessage:)]) {
                [self.delegate onGetLeaveVideoChatMessage:info];
            }
        }
        break;
            
        default:
            break;
    } 
}

- (void)onConnectionStatusChanged:(AlivcLiveConnectionStatus)status {
    
    if (status == AlivcLiveConnectionStatusClose) {
        NSLog(@"掉线");
        if (self.delegate) {
            [self.delegate onGetNetworkStatusMessage:0];
        }
    }
    if (status == AlivcLiveConnectionStatusLogOffByUser) {
        NSLog(@"用户自己下线");
    }
    if (status == AlivcLiveConnectionStatusLogOffByServer) {
        NSLog(@"server端下线");
        if (self.delegate) {
            [self.delegate onGetNetworkStatusMessage:1];
        }
    }
}

@end
