//
//  AppServerCommunication.h
//  DemoAlivcLive
//
//  Created by shiping.csp on 2017/1/11.
//  Copyright © 2017年 Alivc. All rights reserved.
//

#import <Foundation/Foundation.h>

#import "UserInfo.h"
#import "RoomInfoModel.h"
#import "MNSInfoModel.h"
#import <AlivcLiveChatRoom/AlivcLiveChatRoom.h>

@interface SendMessageManager : NSObject

+(void) userLogIn:(NSString*)userName password:(NSString*)password block:(void (^)(UserInfo* userInfo, NSError *error))block;

+(void) getRoomUsers:(NSString*)roomId block:(void (^)(NSMutableArray<UserInfo*>* userInfos, NSError *error))block;

+(void) getAppLiveList:(void (^)(NSMutableArray<RoomInfoModel*>* roomInfos, NSError *error))block;

+(void) creatLive:(NSString*)uid description:(NSString*)description block:(void (^)(RoomInfoModel* roomInfo, MNSInfoModel* mnsInfo, NSError *error))block;

+(void)watchLive:(NSString*)uid roomId:(NSString*)roomId block:(void (^)(MNSInfoModel* mnsInfo, NSError *error))block;

+(void)likeWatch:(NSString*)uid roomId:(NSString*)roomId block:(void (^)(NSError *error))block;

+(void)leaveLive:(NSString*)roomId block:(void (^)(NSError *error))block;

+(void)sendLiveComments:(NSString*)roomId uid:(NSString*)uid comments:(NSString*)comments block:(void (^)(NSError *error))block;

+(void)leaveWatch:(NSString*)roomId uid:(NSString*)uid block:(void (^)(NSError *error))block;

//inviterType:邀请是否为观众 #1是观众 2 主播
+(void)inviteVideoCall:(NSString*)roomId inviterUid:(NSString*)inviterUid inviteeUids:(NSArray<NSString*>*)inviteeUids inviterType:(int)inviterType block:(void (^)(NSError *error))block;

//inviterUid:邀请连麦ID
//inviteeUid:被邀请连麦ID
//status:是否同意状态 #1同意 2 不同意
//inviterType:邀请是否为观众 #1是观众 2 主播
//inviteeType:被邀请是否为观众 #1是观众 2 主播
+(void)sendVideoCallFeedBack:(NSString*)inviterUid inviteeUid:(NSString*)inviteeUid status:(int)status inviterType:(int)inviterType inviteeType:(int)inviteeType block:(void (^)(NSURL* mainPlayUrl,NSArray<NSURL*>* playUrls,NSArray<NSString*>* Uids,NSString* rtmpUrl,NSError *error))block;

+(void)closeVideoCall:(NSString*)roomId block:(void (^)(NSError *error))block;

+(void)leaveVideoCall:(NSString*)roomId uid:(NSString*)uid block:(void (^)(NSError *error))block;

+(void)getMnsTopicInfo:(NSString*)topic tags:(NSArray*)tags block:(void (^)(AlivcWebSocketInfoModel *infoModel,NSError *error))block;

+(void)quitChatRoomSuccess:(void (^)())successBlock
                      error:(void (^)(NSError *error))errorBlock;

+(void)joinChatRoomWithWebSocketInfoModel:(AlivcWebSocketInfoModel *)model
                                   success:(void (^)())successBlock
                                     error:(void (^)(NSError *error))errorBlock;

@end
