//
//  LiveRoomView.m
//  DemoAlivcLive
//
//  Created by LYZ on 16/8/22.
//  Copyright © 2016年 Alivc. All rights reserved.
//

#import "LiveRoomView.h"
#import "MBProgressHUD.h"
#import "chatView.h"

@interface LiveRoomView()

@property (nonatomic, strong) MBProgressHUD *hud;

@property (nonatomic, strong) NSMutableArray<NSDictionary*> *viewMapArray;

@end

@implementation LiveRoomView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setupSubviews];
    }
    return self;
}

- (void)dealloc {
    
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}


- (void)setupSubviews {
    
    self.viewMapArray = [NSMutableArray array];
    
    CGFloat width = (kAlivcLiveScreenWidth - 50) / 4;
    CGFloat height = width / 2;
    
    UIFont *font = [UIFont systemFontOfSize:15.f];
    
    self.backgroundColor = kAlivcColor;
    
    self.mediaPalyerView = [[UIView alloc] initWithFrame:[UIScreen mainScreen].bounds];
    self.mediaPalyerView.backgroundColor = [UIColor whiteColor];
    [self addSubview:self.mediaPalyerView];
    
    [self loadChatTableView];
    
    self.textView = [[UITextView alloc] initWithFrame:CGRectMake(kAlivcLiveScreenWidth - 250,100,250,350)];
    self.textView.textColor = [UIColor redColor];
    self.textView.font = [UIFont fontWithName:@"Arial" size:12.0];
    self.textView.backgroundColor = [UIColor clearColor];
    self.textView.userInteractionEnabled = NO;
    //[self addSubview:self.textView];
    
    UIImage* imgBack = [UIImage imageNamed:@"liveClose"];
    self.doneBtn = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.doneBtn setBackgroundImage:imgBack forState:(UIControlStateNormal)];
    self.doneBtn.frame = CGRectMake(self.frame.size.width-20-imgBack.size.width, 30, imgBack.size.width, imgBack.size.height);
    self.doneBtn.hidden = NO;
    [self addSubview:self.doneBtn];
    self.doneBtn.userInteractionEnabled = YES;
    
    UIImage* imgChat = [UIImage imageNamed:@"liveChat"];
    UIImage* imgChatDisc = [UIImage imageNamed:@"disconnect"];
    self.connectBtn = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.connectBtn setBackgroundImage:imgChat forState:(UIControlStateNormal)];
    [self.connectBtn setBackgroundImage:imgChatDisc forState:(UIControlStateSelected)];
    self.connectBtn.frame = CGRectMake(self.frame.size.width-20-imgBack.size.width, self.frame.size.height-30-imgBack.size.height, imgChat.size.width, imgChat.size.height);
    self.connectBtn.hidden = NO;
    [self addSubview:self.connectBtn];
    self.connectBtn.userInteractionEnabled = NO;
    
    UIImage* imgLike = [UIImage imageNamed:@"Like"];
    self.spotButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.spotButton setBackgroundImage:imgLike forState:(UIControlStateNormal)];
    self.spotButton.frame = CGRectMake(self.frame.size.width-20-imgBack.size.width-20-imgChat.size.width, self.frame.size.height-30-imgBack.size.height, imgLike.size.width, imgLike.size.height);
    self.spotButton.hidden = NO;
    [self addSubview:self.spotButton];
    self.spotButton.userInteractionEnabled = NO;
    
    self.headBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
    self.headBtn.frame = CGRectMake(10, 30, 200, 40);
    [self.headBtn setTitleColor:kAlivcColor forState:(UIControlStateNormal)];
    [self.headBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
    [self.headBtn.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
    [self.headBtn setBackgroundColor:[UIColor colorWithRed:0x6f / 255.0 green:0x6f / 255.0 blue:0x6f / 255.0 alpha:0.5]];
    self.headBtn.clipsToBounds = YES;
    self.headBtn.layer.cornerRadius = 20;
    self.headBtn.hidden = NO;
    [self addSubview:self.headBtn];
    
    self.headImg = [[UIImageView alloc] initWithFrame:CGRectMake(10, 30, 40, 40)];
    self.headImg.image = [UIImage imageNamed:@"headImg.png"];
    self.headImg.hidden = NO;
    [self addSubview:self.headImg];
    
    self.nameLabel = [[UILabel alloc] init];
    self.nameLabel.textColor = [UIColor whiteColor];
    self.nameLabel.frame = CGRectMake(60, 30, 200, 40);
    self.nameLabel.font = [UIFont systemFontOfSize:17.f];
    self.nameLabel.textAlignment = NSTextAlignmentLeft;
    self.nameLabel.hidden = NO;
    [self addSubview:self.nameLabel];
    
//    self.nameLabel = [[UILabel alloc] init];
//    self.nameLabel.textColor = [UIColor blackColor];
//    self.nameLabel.frame = CGRectMake(width * 3 + 40, 25, width + 10, height);
//    self.nameLabel.font = [UIFont systemFontOfSize:14.f];
//    self.nameLabel.textAlignment = NSTextAlignmentCenter;
//    [self addSubview:self.nameLabel];
//    
//    self.timeLabel = [[UILabel alloc] init];
//    self.timeLabel.textColor = [UIColor blackColor];
//    self.timeLabel.frame = CGRectMake(width * 3 + 40, 80, width + 10, height);
//    self.timeLabel.font = [UIFont systemFontOfSize:14.f];
//    self.timeLabel.textAlignment = NSTextAlignmentCenter;
//    [self addSubview:self.timeLabel];
    
    UIImage* imgBeauty = [UIImage imageNamed:@"Beauty"];
    UIImage* imgToggle = [UIImage imageNamed:@"Camera"];
    
    self.skinButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.skinButton setBackgroundImage:imgBeauty forState:(UIControlStateNormal)];
    self.skinButton.frame = CGRectMake(self.frame.size.width-(imgBeauty.size.width+20)*3, self.frame.size.height-30-imgBack.size.height,imgBeauty.size.width,imgBeauty.size.height);
    //[self addSubview:self.skinButton];
    
    //toggleButton
    self.toggleButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.toggleButton setBackgroundImage:imgToggle forState:(UIControlStateNormal)];
    self.toggleButton.frame = CGRectMake(self.frame.size.width-(imgBeauty.size.width+20)*4, self.frame.size.height-30-imgBack.size.height,imgToggle.size.width,imgToggle.size.height);
    //[self addSubview:self.toggleButton];
    
//    self.skinButton = [[UIButton alloc] init];
//    [self.skinButton.layer setMasksToBounds:YES];
//    [self.skinButton.layer setCornerRadius:10.0];
//    [self.skinButton setTitle:@"关闭美颜" forState:UIControlStateNormal];
//    [self.skinButton setTitle:@"开启美颜" forState:(UIControlStateSelected)];
//    [self.skinButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
//    self.skinButton.backgroundColor = kAlivcColor;
//    self.skinButton.titleLabel.font = font;
//    self.skinButton.frame = CGRectMake(10, 80, width, height);
//    
//    self.toggleButton = [[UIButton alloc] init];
//    [self.toggleButton.layer setMasksToBounds:YES];
//    [self.toggleButton.layer setCornerRadius:10.0];
//    [self.toggleButton setTitle:@"摄像头" forState:UIControlStateNormal];
//    [self.toggleButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
//    self.toggleButton.backgroundColor = kAlivcColor;
//    self.toggleButton.titleLabel.font = font;
//    self.toggleButton.frame = CGRectMake(width + 20, 80, width, height);
    
    self.chattextField = [[UITextField alloc] init];
    self.chattextField.frame = CGRectMake(CGRectGetMinX(self.chatTableView.frame), CGRectGetMaxY(self.chatTableView.frame), CGRectGetWidth(self.chatTableView.frame) - 40, 40);
    self.chattextField.placeholder = @"发送弹幕";
    self.chattextField.font = [UIFont systemFontOfSize:15.f];
    self.chattextField.clearButtonMode = UITextFieldViewModeWhileEditing;
    self.chattextField.borderStyle = UITextBorderStyleRoundedRect;
    //[self addSubview:self.chattextField];
    
    self.chatSendButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    self.chatSendButton.frame = CGRectMake(CGRectGetMaxX(self.chattextField.frame), CGRectGetMinY(self.chattextField.frame), 40, 40);
    [self.chatSendButton setTitle:@"发送" forState:(UIControlStateNormal)];
    [self.chatSendButton.titleLabel setFont:[UIFont systemFontOfSize:15.0]];
    self.chatSendButton.backgroundColor = kAlivcColor;
    [self.chatSendButton.layer setMasksToBounds:YES];
    [self.chatSendButton.layer setCornerRadius:10.0];
    //[self addSubview:self.chatSendButton];
    
    self.loadingView = [[UIImageView alloc] init];
    self.loadingView.image = [UIImage imageNamed:@"img_loading"];
    self.loadingView.frame = [UIScreen mainScreen].bounds;
    
    self.hud = [MBProgressHUD showHUDAddedTo:self.loadingView animated:YES];
    self.hud.label.text = @"Loading...";
    self.hud.label.font = font; 

    self.pushView = [[ChatView alloc] initWithFrame:[self getChatViewFrameWithIndex:0] ];
    self.pushView.delegate = self;
    self.pushView.closeBtn.hidden = YES;
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillShow:) name:UIKeyboardWillShowNotification object:nil];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillhide:) name:UIKeyboardWillHideNotification object:nil]; 
}


- (void)loadChatTableView {
    
    self.chatTableView = [[UITableView alloc] initWithFrame:CGRectMake(10, kAlivcLiveScreenHeight - 210, kAlivcLiveScreenWidth / 2, 170) style:(UITableViewStylePlain)];
    self.chatTableView.backgroundColor = [UIColor clearColor];
    self.chatTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    [self.chatTableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"chatTableViewID"];
    //[self addSubview:self.chatTableView];
    
}


- (void)setChatTableviewDataSourceDelegate:(id<UITableViewDataSource, UITableViewDelegate>)dataSourceDelegate {
    
    self.chatTableView.dataSource = dataSourceDelegate;
    self.chatTableView.delegate = dataSourceDelegate;
    [self.chatTableView reloadData];
}

- (void)showLoadingViewWithMessage:(NSString *)message {
    
    self.hud.label.text = message;
    self.hud.alpha = 0.8;
    [self insertSubview:self.loadingView belowSubview:self.doneBtn];
}

- (void)hideLoadingView {
    
    [self.loadingView removeFromSuperview];
}


- (CGRect)getChatViewFrameWithIndex:(NSInteger)index {
    
    CGRect rect = CGRectZero;
//    rect.origin.y = kAlivcLiveScreenHeight-192;
//    rect.origin.x = kAlivcLiveScreenWidth - 110 * (index+2);
    rect.origin.y = kAlivcLiveScreenHeight - 80 - 144*(index+1)-15*(index+0);
    rect.origin.x = kAlivcLiveScreenWidth - 85;
    rect.size = CGSizeMake(81, 144);
    
    return rect;
}

- (NSArray<UIView *> *)addChatViewsWithArray:(NSArray*)playArray uidArrays:(NSArray*)uidsArray
{
    NSInteger currentChatCount = self.viewMapArray.count;
    if (currentChatCount >= 3) {
        // 如果连麦已经有三个 则返回空 不继续添加连麦窗口
        return nil;
    }
    NSMutableArray *viewArray = [NSMutableArray array];
    
    int count = (int)[playArray count];
    for (int index = 0; index < count; index++) {
        
        ChatView *chatView = [[ChatView alloc] initWithFrame:[self getChatViewFrameWithIndex:index + currentChatCount + 1] ];
        chatView.chatView.tag = 998877 + index;
        chatView.nameLabel.text = [uidsArray objectAtIndex:index];
        chatView.closeBtn.hidden = YES;
        chatView.delegate = self;
        
        [self addSubview:chatView];
        [viewArray addObject:chatView.chatView];
        
        NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
        [dic setObject:chatView forKey:[playArray objectAtIndex:index]];
        [self.viewMapArray addObject:dic];
    }
    return viewArray;
}

- (void)removeAllChatViews {
    
    for (NSDictionary* dic in self.viewMapArray) {
        UIView* view = [[dic allValues] objectAtIndex:0];
        [view removeFromSuperview];
    }
    [self.viewMapArray removeAllObjects];
}

- (void)removeChatViewsWithUrl:(NSString*)playUrl {
    
    int findIndex = -1;
    NSURL* url = [NSURL URLWithString:playUrl];
    for (int i=0; i< (int)[self.viewMapArray count]; i++) {
        NSDictionary* dic = [self.viewMapArray objectAtIndex:i];
        
        NSArray* views = [dic allValues];
        UIView* view = [views objectAtIndex:0];
        
        if([dic objectForKey:url] != nil) {
            findIndex = i;
            [view removeFromSuperview];
        }
        
        if (findIndex != -1) {
            [UIView animateWithDuration:0.5 animations:^{
                view.frame = [self getChatViewFrameWithIndex:i - 1];
            }];
            
        }
    }
    
    if (findIndex != -1) {
        [self.viewMapArray removeObjectAtIndex:findIndex];
    }
}

#pragma mark -Notification Action
- (void)keyboardWillShow:(NSNotification *)notification {
    
    //获取键盘的高度
    NSDictionary *userInfo = [notification userInfo];
    NSValue *aValue = [userInfo objectForKey:UIKeyboardFrameEndUserInfoKey];
    CGRect keyboardRect = [aValue CGRectValue];
    int height = keyboardRect.size.height;
    
    self.chatTableView.frame = CGRectMake(10, kAlivcLiveScreenHeight - 210 - height, kAlivcLiveScreenWidth / 2, 170);
    self.chattextField.frame = CGRectMake(CGRectGetMinX(self.chatTableView.frame), CGRectGetMaxY(self.chatTableView.frame), CGRectGetWidth(self.chatTableView.frame) - 40, 40);
    self.chatSendButton.frame = CGRectMake(CGRectGetMaxX(self.chattextField.frame), CGRectGetMinY(self.chattextField.frame), 40, 40);
    
    
}

- (void)keyboardWillhide:(NSNotification *)notification {
    
    self.chatTableView.frame = CGRectMake(10, kAlivcLiveScreenHeight - 210, kAlivcLiveScreenWidth / 2, 170);
    self.chattextField.frame = CGRectMake(CGRectGetMinX(self.chatTableView.frame), CGRectGetMaxY(self.chatTableView.frame), CGRectGetWidth(self.chatTableView.frame) - 40, 40);
    self.chatSendButton.frame = CGRectMake(CGRectGetMaxX(self.chattextField.frame), CGRectGetMinY(self.chattextField.frame), 40, 40);
}

-(void) onClickChatViewCloseButtonWithView:(UIView *)view
{
    
}


@end
