//
//  LoginView.m
//  DemoAlivcLive
//
//  Created by LYZ on 16/8/22.
//  Copyright © 2016年 Alivc. All rights reserved.
//

#import "LoginView.h"

@implementation LoginView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setupSubviews];
    }
    return self;
}


- (void)setupSubviews {
    
    int w = 343;
    int x = kAlivcLiveScreenWidth/2-343/2;
    if (x<10) {
        x = 10;
        w = kAlivcLiveScreenWidth-20;
    }
    
    self.backgroundColor = [UIColor whiteColor];
    
    UIView *nameView = [[UIView alloc] initWithFrame:CGRectMake(x, 130, w, 40)];
    nameView.backgroundColor = [UIColor colorWithRed:240 / 255.0 green:240 / 255.0 blue:240 / 255.0 alpha:1];
    [nameView.layer setMasksToBounds:YES];
    nameView.layer.borderWidth=1;
    nameView.layer.borderColor =  [[UIColor grayColor] CGColor];
    [nameView.layer setCornerRadius:20.0f];
    [self addSubview:nameView];
    
    UIView *passwordView = [[UIView alloc] initWithFrame:(CGRectMake(CGRectGetMinX(nameView.frame), CGRectGetMaxY(nameView.frame) + 10, (kAlivcLiveScreenWidth - 100), 40))];
    passwordView.backgroundColor = [UIColor colorWithRed:240 / 255.0 green:240 / 255.0 blue:240 / 255.0 alpha:1];
    [passwordView.layer setMasksToBounds:YES];
    [passwordView.layer setCornerRadius:20.0f];
    //[self addSubview:passwordView];
    
    self.nameTextField = [[UITextField alloc] initWithFrame: CGRectMake(10, 0, w-10, 40)];
    self.nameTextField.textColor = kAlivcColor;
    self.nameTextField.borderStyle = UITextBorderStyleNone;
    self.nameTextField.clearButtonMode = UITextFieldViewModeWhileEditing;
    self.nameTextField.placeholder = @"用户名";
    self.nameTextField.textAlignment = NSTextAlignmentLeft;
    [nameView addSubview:self.nameTextField];
    
    self.passwordTextField = [[UITextField alloc] initWithFrame: CGRectMake(10, 0, CGRectGetWidth(passwordView.frame) - 10, CGRectGetHeight(passwordView.frame))];
    self.passwordTextField.textColor = kAlivcColor;
    self.passwordTextField.borderStyle = UITextBorderStyleRoundedRect;
    self.passwordTextField.clearButtonMode = UITextFieldViewModeWhileEditing;
    self.passwordTextField.placeholder = @"password";
    self.passwordTextField.hidden = YES;
    [passwordView addSubview:self.passwordTextField];    
    
    self.backButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    self.backButton.frame = CGRectMake((kAlivcLiveScreenWidth / 2) - 36 - 5, CGRectGetMaxY(passwordView.frame) + 20, 36, 35);
    [self.backButton setImage:[UIImage imageNamed:@"login_phone_back"] forState:(UIControlStateNormal)];
    [self.backButton setTitleColor:kAlivcColor forState:(UIControlStateNormal)];
    [self.backButton.titleLabel setFont:[UIFont systemFontOfSize:30.f]];
    self.backButton.hidden = YES;
    [self addSubview:self.backButton];
    
    self.nextButton = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
    self.nextButton.frame = CGRectMake(x, CGRectGetMaxY(nameView.frame) + 30, w, 40);
    //[self.nextButton setImage:[UIImage imageNamed:@"login_phone_next"] forState:(UIControlStateNormal)];
    [self.nextButton setTitleColor:kAlivcColor forState:(UIControlStateNormal)];
    [self.nextButton setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
    [self.nextButton.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
    [self.nextButton setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
    [self.nextButton setTitle:@"登  录" forState:UIControlStateNormal];
    self.nextButton.clipsToBounds = YES;
    self.nextButton.layer.cornerRadius = 20;
    [self.nextButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [self addSubview:self.nextButton];
    
    
    UIImageView *bgImgView = [[UIImageView alloc] initWithFrame:CGRectMake(0, self.frame.size.height-358, self.frame.size.width, 358)];
    [bgImgView setImage:[UIImage imageNamed:@"BG"]];
    [self addSubview:bgImgView];
    [self sendSubviewToBack:bgImgView];
}

@end
