//
//  StartLiveView.h
//  DemoAlivcLive
//
//  Created by LYZ on 16/8/23.
//  Copyright © 2016年 Alivc. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "chatView.h"
#import "chatListView.h"

@protocol StartLiveViewDelegate <NSObject>

- (void)onClickChatViewCloseButtonWithUrl:(NSString*)playUrl;

@end

@interface StartLiveView : UIView<ChatViewCloseDelegate>

@property (nonatomic, strong) UIView *descView;
@property (nonatomic, strong) UITextField *descTextFeild;
@property (nonatomic, strong) UIButton *descButton;
@property (nonatomic, strong) UIView *publisherView;
@property (nonatomic, strong) UIButton *doneBtn;
@property (nonatomic, strong) UIButton *connectBtn;
@property (nonatomic, strong) UIButton *disConnectBtn;
@property (nonatomic, strong) UIButton *pushButton;
@property (nonatomic, strong) UIButton *skinButton;
@property (nonatomic, strong) UIButton *toggleButton;
@property (nonatomic, strong) UIButton *closeAudio;
@property (nonatomic, strong) UIButton *closeVideo;
@property (nonatomic, strong) UITableView *chatTableView;
@property (nonatomic, strong) UILabel *nameLabel;
@property (nonatomic, strong) UIButton *addButton;

@property (nonatomic, strong) UIImageView *headImg;
@property (nonatomic, strong) UIButton *headBtn;
@property (nonatomic, strong) UITextView *textView;

@property (nonatomic, strong) UIImageView *loadingView;

//@property (nonatomic, strong) UIView *liveListView;
//@property (nonatomic, strong) UITableView *liveListTableView;
@property (nonatomic, strong) UIButton *liveListCancelButton;
@property (nonatomic, strong) UIButton *liveListOkButton;
@property (nonatomic, strong) UIView *lineView;

@property (nonatomic, strong) ChatListView *chatListView;

@property (nonatomic, assign) id<StartLiveViewDelegate> delegate;

- (void)setTableViewDataSourceDelegate:(id<UITableViewDataSource, UITableViewDelegate>)dataSourceDelegate;


- (void)showLoadingView;

- (void)hideLoadingView;

- (NSArray<UIView *> *)addChatViewsWithArray:(NSArray*)playArray uids:(NSArray*)uids;
- (void)removeChatViewsWithUrl:(NSString*)playUrl;

- (void)removeAllChatViews;

-(void)createLiveChangeView;

@end
