//
//  StartLiveView.m
//  DemoAlivcLive
//
//  Created by LYZ on 16/8/23.
//  Copyright © 2016年 Alivc. All rights reserved.
//

#import "StartLiveView.h"
#import "chatView.h"
@interface StartLiveView ()

@property (nonatomic, strong) NSMutableArray<NSDictionary*> *viewMapArray;

@end

@implementation StartLiveView

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self setupSubViews];
    }
    return self;
}


- (void)setupSubViews {
    
    self.viewMapArray = [NSMutableArray array];
    
    CGFloat width = (kAlivcLiveScreenWidth - 50) / 4;
    CGFloat height = width / 2;
    
    UIFont *font = [UIFont systemFontOfSize:15.f];
    
    self.publisherView = [[UIView alloc] init];
    self.publisherView.frame = [UIScreen mainScreen].bounds;
//    self.publisherView.autoresizesSubviews = YES;
//    self.publisherView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
    [self addSubview:self.publisherView];
    
    UIImage* imgBeauty = [UIImage imageNamed:@"Beauty"];
    UIImage* imgToggle = [UIImage imageNamed:@"Camera"];
    UIImage* imgBack = [UIImage imageNamed:@"liveBack"];
    
    //doneButton
    self.doneBtn = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.doneBtn setBackgroundImage:imgBack forState:(UIControlStateNormal)];
    self.doneBtn.frame = CGRectMake(10, 30,imgBack.size.width,imgBack.size.height);
    self.doneBtn.hidden = NO;
    [self addSubview:self.doneBtn];
    [self bringSubviewToFront:self.doneBtn];
    
    //skinButton
    self.skinButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.skinButton setBackgroundImage:imgBeauty forState:(UIControlStateNormal)];
    self.skinButton.frame = CGRectMake(self.frame.size.width-imgBeauty.size.width-imgToggle.size.width-20-20, 30,imgBeauty.size.width,imgBeauty.size.height);
    [self addSubview:self.skinButton];
    
    //toggleButton
    self.toggleButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    [self.toggleButton setBackgroundImage:imgToggle forState:(UIControlStateNormal)];
    self.toggleButton.frame = CGRectMake(self.frame.size.width-imgToggle.size.width-20, 30,imgToggle.size.width,imgToggle.size.height);
    [self addSubview:self.toggleButton];
    
    self.textView = [[UITextView alloc] initWithFrame:CGRectMake(kAlivcLiveScreenWidth - 250, 60, 250, 350)];
    self.textView.textColor = [UIColor redColor];
    self.textView.font = [UIFont fontWithName:@"Arial" size:12.0];
    self.textView.backgroundColor = [UIColor clearColor];
    self.textView.userInteractionEnabled = NO;
    [self addSubview:self.textView];
    
    self.descView = [[UIView alloc] initWithFrame:[UIScreen mainScreen].bounds];
    self.descView.backgroundColor = [UIColor colorWithWhite:0 alpha:0];
    //[self addSubview:self.descView];
    
    self.descTextFeild = [[UITextField alloc] initWithFrame:(CGRectMake((kAlivcLiveScreenWidth - 200) / 2, (kAlivcLiveScreenHeight - 100) / 2, 200, 50))];
    self.descTextFeild.clearButtonMode = UITextFieldViewModeWhileEditing;
    UIColor *color = [UIColor whiteColor];
    self.descTextFeild.attributedPlaceholder = [[NSAttributedString alloc] initWithString:@"填写直播主题" attributes:@{NSForegroundColorAttributeName: color}];
    self.descTextFeild.borderStyle = UITextBorderStyleNone;
    self.descTextFeild.textColor = [UIColor whiteColor];
    [self addSubview:self.descTextFeild];
    self.descTextFeild.textAlignment = NSTextAlignmentCenter;
    
    int w = 343;
    int x = kAlivcLiveScreenWidth/2-343/2;
    if (x<10) {
        x = 10;
        w = kAlivcLiveScreenWidth-20;
    }
    self.lineView = [[UIView alloc] initWithFrame:CGRectMake(10, self.descTextFeild.frame.origin.y+self.descTextFeild.frame.size.height-5, self.frame.size.width-20, 1)];
    [self.lineView setBackgroundColor:[UIColor whiteColor]];
    [self addSubview:self.lineView];
    self.descButton = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
    self.descButton.frame = CGRectMake(x, self.lineView.frame.size.height+self.lineView.frame.origin.y + 40, w, 40);
    [self.descButton setTitleColor:kAlivcColor forState:(UIControlStateNormal)];
    [self.descButton setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
    [self.descButton.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
    [self.descButton setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
    [self.descButton setTitle:@"开始直播" forState:UIControlStateNormal];
    self.descButton.clipsToBounds = YES;
    self.descButton.layer.cornerRadius = 20;
    [self.descButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    [self addSubview:self.descButton];
    
    self.loadingView = [[UIImageView alloc] init];
    self.loadingView.image = [UIImage imageNamed:@"img_loading"];
    self.loadingView.backgroundColor = kAlivcColor;
    self.loadingView.frame = CGRectMake(100, 200, 90, 160);
    
//    self.addButton = [[UIButton alloc] init];
//    [self.addButton.layer setMasksToBounds:YES];
//    [self.addButton.layer setCornerRadius:10.0];
//    [self.addButton setTitle:@"添加连麦" forState:UIControlStateNormal];
//    [self.addButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
//    self.addButton.backgroundColor = kAlivcColor;
//    self.addButton.titleLabel.font = font;
//    self.addButton.frame = CGRectMake(width * 3 + 40, height + 40, width, height);
//    self.addButton.hidden = YES;
//    [self addSubview:self.addButton];
    
    self.headBtn = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
    self.headBtn.frame = CGRectMake(10, 30, 200, 40);
    [self.headBtn setTitleColor:kAlivcColor forState:(UIControlStateNormal)];
    [self.headBtn setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
    [self.headBtn.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
    [self.headBtn setBackgroundColor:[UIColor colorWithRed:0x6f / 255.0 green:0x6f / 255.0 blue:0x6f / 255.0 alpha:0.5]];
    self.headBtn.clipsToBounds = YES;
    self.headBtn.layer.cornerRadius = 20;
    self.headBtn.hidden = YES;
    [self addSubview:self.headBtn];
    
    self.headImg = [[UIImageView alloc] initWithFrame:CGRectMake(10, 30, 40, 40)];
    self.headImg.image = [UIImage imageNamed:@"headImg.png"];
    self.headImg.hidden = YES;
    [self addSubview:self.headImg];
    
    self.nameLabel = [[UILabel alloc] init];
    self.nameLabel.textColor = [UIColor whiteColor];
    self.nameLabel.frame = CGRectMake(60, 30, 200, 40);
    self.nameLabel.font = [UIFont systemFontOfSize:17.f];
    self.nameLabel.textAlignment = NSTextAlignmentLeft;
    self.nameLabel.hidden = YES;
    [self addSubview:self.nameLabel];
    
    [self loadChatTableView];
    
    [self loadliveListTableView];
    
    self.connectBtn = [[UIButton alloc] init];
    [self.connectBtn.layer setMasksToBounds:YES];
    [self.connectBtn.layer setCornerRadius:10.0];
    [self.connectBtn setTitle:@"开始连麦" forState:UIControlStateNormal];
    [self.connectBtn setTitle:@"结束连麦" forState:(UIControlStateSelected)];
    [self.connectBtn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    self.connectBtn.backgroundColor = kAlivcColor;
    self.connectBtn.titleLabel.font = font;
    self.connectBtn.frame = CGRectMake(width + 20, 20, width, height);
    self.connectBtn.hidden = YES;
    [self addSubview:self.connectBtn];
    
    self.pushButton = [[UIButton alloc] init];
    [self.pushButton.layer setMasksToBounds:YES];
    [self.pushButton.layer setCornerRadius:10.0];
    [self.pushButton setTitle:@"开始推流" forState:UIControlStateNormal];
    [self.pushButton setTitle:@"结束推流" forState:(UIControlStateSelected)];
    [self.pushButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    self.pushButton.backgroundColor = kAlivcColor;
    self.pushButton.titleLabel.font = font;
    self.pushButton.frame = CGRectMake(width * 2 + 30, 20, width, height);
    self.pushButton.hidden = YES;
    [self addSubview:self.pushButton];
    
    self.addButton = [UIButton buttonWithType:(UIButtonTypeCustom)];
    UIImage* imgChat = [UIImage imageNamed:@"liveChat"];
    [self.addButton setBackgroundImage:imgChat forState:(UIControlStateNormal)];
    self.addButton.hidden = YES;
    [self addSubview:self.addButton];
    
    self.closeAudio = [[UIButton alloc] init];
    [self.closeAudio.layer setMasksToBounds:YES];
    [self.closeAudio.layer setCornerRadius:10.0];
    [self.closeAudio setTitle:@"关闭音频" forState:UIControlStateNormal];
    [self.closeAudio setTitle:@"开启音频" forState:(UIControlStateSelected)];
    [self.closeAudio setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    self.closeAudio.backgroundColor = kAlivcColor;
    self.closeAudio.titleLabel.font = font;
    self.closeAudio.frame = CGRectMake(width + 20, height + 40, width, height);
    self.closeAudio.hidden = YES;
    [self addSubview:self.closeAudio];
    
    self.closeVideo = [[UIButton alloc] init];
    [self.closeVideo.layer setMasksToBounds:YES];
    [self.closeVideo.layer setCornerRadius:10.0];
    [self.closeVideo setTitle:@"关闭视频" forState:UIControlStateNormal];
    [self.closeVideo setTitle:@"开启视频" forState:(UIControlStateSelected)];
    [self.closeVideo setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
    self.closeVideo.backgroundColor = kAlivcColor;
    self.closeVideo.titleLabel.font = font;
    self.closeVideo.hidden = YES;
    self.closeVideo.frame = CGRectMake(width * 2 + 30, height + 40, width, height);
    //    [self addSubview:self.closeVideo];
    
    [self bringSubviewToFront:self.chatListView];
}

-(void)createLiveChangeView
{
    self.descTextFeild.hidden = YES;
    self.lineView.hidden = YES;
    self.descButton.hidden = YES;
    self.addButton.hidden = NO;
    self.headImg.hidden = NO;
    self.nameLabel.hidden = NO;
    self.headBtn.hidden = NO;

    int y = self.frame.size.height - self.doneBtn.frame.size.height - 30;
    int x = self.frame.size.width - self.doneBtn.frame.size.width - 20;
    UIImage* liveCloseImg = [UIImage imageNamed:@"liveClose"];
    [self.doneBtn setBackgroundImage:liveCloseImg forState:(UIControlStateNormal)];
    self.doneBtn.frame = CGRectMake(x, 30, liveCloseImg.size.width, liveCloseImg.size.height);
    
    self.addButton.frame = CGRectMake(x, y, self.doneBtn.frame.size.width, self.doneBtn.frame.size.height);
    
    x -= (self.addButton.frame.size.width+20);
    self.toggleButton.frame = CGRectMake(x, y, self.toggleButton.frame.size.width, self.toggleButton.frame.size.height);
    
    x -= (self.toggleButton.frame.size.width+20);
    self.skinButton.frame = CGRectMake(x, y, self.toggleButton.frame.size.width, self.toggleButton.frame.size.height);
}

- (void)loadliveListTableView {
    
//    self.liveListView = [[UIView alloc] initWithFrame:CGRectMake((kAlivcLiveScreenWidth - 200) / 2, (kAlivcLiveScreenHeight - 350) / 2, 200, 320)];
//    self.liveListView.backgroundColor = [UIColor lightGrayColor];
//    [self.liveListView.layer setCornerRadius:15.0];
//    [self addSubview:self.liveListView];
//    
//    self.liveListOkButton = [[UIButton alloc] init];
//    [self.liveListOkButton.layer setMasksToBounds:YES];
//    [self.liveListOkButton.layer setCornerRadius:10.0];
//    [self.liveListOkButton setTitle:@"确定" forState:UIControlStateNormal];
//    [self.liveListOkButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
//    self.liveListOkButton.backgroundColor = kAlivcColor;
//    self.liveListOkButton.frame = CGRectMake(100,270, 80, 30);
//    self.liveListOkButton.hidden = NO;
//    [self.liveListView addSubview:self.liveListOkButton];
//    
//    self.liveListCancelButton = [[UIButton alloc] init];
//    [self.liveListCancelButton.layer setMasksToBounds:YES];
//    [self.liveListCancelButton.layer setCornerRadius:10.0];
//    [self.liveListCancelButton setTitle:@"取消" forState:UIControlStateNormal];
//    [self.liveListCancelButton setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
//    self.liveListCancelButton.backgroundColor = kAlivcColor;
//    self.liveListCancelButton.frame = CGRectMake(10, 270, 80, 30);
//    self.liveListCancelButton.hidden = NO;
//    [self.liveListView addSubview:self.liveListCancelButton];
    
//    self.liveListTableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, self.frame.size.width,self.frame.size.height) style:(UITableViewStylePlain)];
//    [self.liveListTableView.layer setMasksToBounds:YES];
//    [self.liveListTableView.layer setCornerRadius:15.0];
//    self.liveListTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
//    [self.liveListTableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"liveListTableViewID"];
//    [self.liveListView addSubview:self.liveListTableView];
//    self.liveListView.hidden = YES;
}

- (void)loadChatTableView {

    self.chatListView = [[ChatListView alloc] initWithFrame:[UIScreen mainScreen].bounds];
    self.chatListView.backgroundColor = [UIColor colorWithWhite:0.5 alpha:0.8];
    self.chatListView.hidden = YES;
    [self addSubview:self.chatListView];
    
    self.chatTableView = [[UITableView alloc] initWithFrame:CGRectMake(180, 100, kAlivcLiveScreenWidth / 2, 170) style:(UITableViewStylePlain)];
    self.chatTableView.separatorStyle = UITableViewCellSeparatorStyleNone;
    self.chatTableView.backgroundColor = [UIColor clearColor];
    [self.chatTableView registerClass:[UITableViewCell class] forCellReuseIdentifier:@"chatTableViewID"];
    //[self addSubview:self.chatTableView];
    
}

- (void)setTableViewDataSourceDelegate:(id<UITableViewDataSource,UITableViewDelegate>)dataSourceDelegate {
    
//    self.liveListTableView.delegate = dataSourceDelegate;
//    self.liveListTableView.dataSource = dataSourceDelegate;
//    
    self.chatTableView.delegate = dataSourceDelegate;
    self.chatTableView.dataSource = dataSourceDelegate;
    
    self.chatListView.tableView_audience.delegate = dataSourceDelegate;
    self.chatListView.tableView_audience.dataSource = dataSourceDelegate;
    
    self.chatListView.tableView_videocall.delegate = dataSourceDelegate;
    self.chatListView.tableView_videocall.dataSource = dataSourceDelegate;
}


- (void)showLoadingView {
    
    [self addSubview:self.loadingView];
    self.connectBtn.userInteractionEnabled = NO;
    self.doneBtn.userInteractionEnabled = NO;
    self.pushButton.userInteractionEnabled = NO;
    
}

- (void)hideLoadingView {
    
    [self.loadingView removeFromSuperview];
    
    self.connectBtn.userInteractionEnabled = YES;
    self.doneBtn.userInteractionEnabled = YES;
    self.pushButton.userInteractionEnabled = YES;
    
}

- (CGRect)getChatViewFrameWithIndex:(NSInteger)index {
    
    CGRect rect = CGRectZero;
    //    rect.origin.y = kAlivcLiveScreenHeight-192;
    //    rect.origin.x = kAlivcLiveScreenWidth - 110 * (index+2);
    rect.origin.y = kAlivcLiveScreenHeight - 80 - 144*(index+1)-15*index;
    rect.origin.x = kAlivcLiveScreenWidth - 85;
    rect.size = CGSizeMake(81, 144);
    
    return rect;
}

- (NSArray<UIView *> *)addChatViewsWithArray:(NSArray*)playArray uids:(NSArray*)uids
{
    
    NSInteger currentChatCount = self.viewMapArray.count;
    if (currentChatCount >= 3) {
        // 如果连麦已经有三个 则返回空 不继续添加连麦窗口
        return nil;
    }
    NSMutableArray *viewArray = [NSMutableArray array];
    
    int count = (int)[playArray count];
    for (int index = 0; index < count; index++) {

        ChatView *chatView = [[ChatView alloc] initWithFrame:[self getChatViewFrameWithIndex:index + currentChatCount] ];
        chatView.chatView.tag = 998877 + index;
        chatView.nameLabel.text = [uids objectAtIndex:index];
        chatView.delegate = self;
        
//        UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(chatViewCloseAction:)];
//        tap.numberOfTapsRequired = 2;
//        [chatView addGestureRecognizer:tap];
        [self addSubview:chatView];
        [viewArray addObject:chatView.chatView];
        
        NSMutableDictionary* dic = [[NSMutableDictionary alloc] init];
        [dic setObject:chatView forKey:[playArray objectAtIndex:index]];
        [self.viewMapArray addObject:dic];
    }
    return viewArray;
    
}

-(void) onClickChatViewCloseButtonWithView:(UIView *)view
{
    NSURL* url = nil;
    for (NSDictionary* dic in self.viewMapArray) {
        NSArray* arry = [dic allValues];
        UIView* dicView = arry[0];
        if (dicView == view) {
            url = [dic allKeys][0];
            break;
        }
    }
    if (url) {
        [self.delegate onClickChatViewCloseButtonWithUrl:[url absoluteString]];
    }
}

- (void)removeChatViewsWithUrl:(NSString*)playUrl {
    
    int findIndex = -1;
    NSURL* url = [NSURL URLWithString:playUrl];
    for (int i=0; i< (int)[self.viewMapArray count]; i++) {
        NSDictionary* dic = [self.viewMapArray objectAtIndex:i];
        
        NSArray* views = [dic allValues];
        UIView* view = [views objectAtIndex:0];
        
        if([dic objectForKey:url] != nil) {
            findIndex = i;
            [view removeFromSuperview];
        }
        
        if (findIndex != -1) {
            [UIView animateWithDuration:0.5 animations:^{
                view.frame = [self getChatViewFrameWithIndex:i - 1];
            }];

        }
    }
    
    if (findIndex != -1) {
        [self.viewMapArray removeObjectAtIndex:findIndex];
    }
}

- (void)removeAllChatViews {
    
    for (NSDictionary* dic in self.viewMapArray) {
        UIView* view = [[dic allValues] objectAtIndex:0];
        [view removeFromSuperview];
    }
    [self.viewMapArray removeAllObjects];
}

- (void)chatViewCloseAction:(UITapGestureRecognizer *)sender {

    NSURL* url = nil;
    UIView* view = sender.view;
    for (NSDictionary* dic in self.viewMapArray) {
        NSArray* arry = [dic allValues];
        UIView* dicView = arry[0];
        if (dicView == view) {
            url = [dic allKeys][0];
            break;
        }
    }
    if (url) {
        [self.delegate onClickChatViewCloseButtonWithUrl:[url absoluteString]];
    }
}

@end
