//
//  LoginView.m
//  DemoAlivcLive
//
//  Created by LYZ on 16/8/22.
//  Copyright © 2016年 Alivc. All rights reserved.
//

#import "chatListView.h"
#import "ALiViewTableViewCell.h"

@implementation ChatListView

-(void)initSegmentControl
{
    NSArray *segmentedArray = [[NSArray alloc]initWithObjects:@"在线观众",@"已连麦观众",nil];
    //初始化UISegmentedControl
    self.segmentControl = [[UISegmentedControl alloc]initWithItems:segmentedArray];
    self.segmentControl.frame = CGRectMake(0, 84, self.frame.size.width, 44);
    self.segmentControl.selectedSegmentIndex = 0;
    self.segmentControl.backgroundColor = [UIColor clearColor];
    self.segmentControl.tintColor = [UIColor colorWithWhite:1 alpha:0.5];
    self.segmentControl.segmentedControlStyle = UISegmentedControlStylePlain;
    
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:[UIColor blackColor],
                         NSForegroundColorAttributeName,
                         [UIFont boldSystemFontOfSize:14],
                         NSFontAttributeName,nil];
    
    [ self.segmentControl setTitleTextAttributes:dic forState:UIControlStateSelected];
    [ self.segmentControl setTitleTextAttributes:dic forState:UIControlStateNormal];
        [self.segmentControl addTarget:self action:@selector(segmentControlChanged:) forControlEvents:UIControlEventValueChanged];
    [self addSubview:self.segmentControl];
}

-(void)segmentControlChanged:(UISegmentedControl*)sender
{
    switch (sender.selectedSegmentIndex) {
        case 0:
            [self.button setTitle:@"开始连麦" forState:UIControlStateNormal];
            self.tableView_videocall.hidden = YES;
            self.tableView_audience.hidden = NO;
            [self.tableView_audience reloadData];
            break;
        case 1:
            [self.button setTitle:@"断开连麦" forState:UIControlStateNormal];
            self.tableView_videocall.hidden = NO;
            self.tableView_audience.hidden = YES;
            [self.tableView_videocall reloadData];

            break;
            
            
        default:
            break;
    }
}


- (void)loadChatTableView {
    
    int y = self.segmentControl.frame.size.height+self.segmentControl.frame.origin.y+5;
    self.tableView_videocall = [[UITableView alloc] initWithFrame:CGRectMake(0, y, kAlivcLiveScreenWidth, self.frame.size.height-120) style:(UITableViewStylePlain)];
    
    self.tableView_videocall.separatorStyle = UITableViewCellSeparatorStyleNone;
    self.tableView_videocall.backgroundColor = [UIColor clearColor];
    [self.tableView_videocall registerClass:[ALiViewTableViewCell class] forCellReuseIdentifier:@"liveListTableViewID"];
    [self addSubview:self.tableView_videocall];
    self.tableView_videocall.hidden = YES;
    
    self.tableView_audience = [[UITableView alloc] initWithFrame:CGRectMake(0, y, kAlivcLiveScreenWidth, self.frame.size.height-120) style:(UITableViewStylePlain)];
    
    self.tableView_audience.separatorStyle = UITableViewCellSeparatorStyleNone;
    self.tableView_audience.backgroundColor = [UIColor clearColor];
    [self.tableView_audience registerClass:[ALiViewTableViewCell class] forCellReuseIdentifier:@"liveListTableViewID"];
    [self addSubview:self.tableView_audience];
}

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        [self initSegmentControl];
        [self loadChatTableView];
        
        self.button = [UIButton buttonWithType:(UIButtonTypeRoundedRect)];
        self.button.frame = CGRectMake((self.frame.size.width-200)/2, self.frame.size.height-120, 200, 40);
        [self.button setTitleColor:kAlivcColor forState:(UIControlStateNormal)];
        [self.button setTitleColor:[UIColor grayColor] forState:(UIControlStateSelected)];
        [self.button.titleLabel setFont:[UIFont systemFontOfSize:17.f]];
        [self.button setBackgroundColor:[UIColor colorWithRed:0x87 / 255.0 green:0x4b / 255.0 blue:0xe0 / 255.0 alpha:1]];
        [self.button setTitle:@"开始连麦" forState:UIControlStateNormal];
        self.button.clipsToBounds = YES;
        self.button.layer.cornerRadius = 20;
        [self.button setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [self addSubview:self.button];
        
        UIImage* backImg = [UIImage imageNamed:@"liveClose"];
        self.backBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        [self.backBtn setBackgroundImage:backImg forState:UIControlStateNormal];
        self.backBtn.frame = CGRectMake(self.frame.size.width-backImg.size.width-20, 30, backImg.size.width, backImg.size.height);
        [self addSubview:self.backBtn];
        [self.backBtn sizeToFit];
    }
    return self;
}

-(BOOL)isToVideoCall
{
    return  self.segmentControl.selectedSegmentIndex == 0;
}

@end
